#!/use/bin/perl -w
use strict;
use JALH::Server;
use JALH::Client;
my $test = 0;
my $msg = "Hey Mate!\n";

#$SIG{CHLD} = sub{print "Client died\n";exit};

my $pid = fork;
if(!defined $pid) {
	die "No space to fork!! :(\n";
} elsif($pid) {			# Parent
	sub client {
		my ($self, $handle, $paddr) = @_;
		chomp(my $t = <$handle>);
		print $self->connected;
		print $handle "$t\n";
		$self->killall if lc $t eq 'killall';
		$self->quit if lc $t eq 'quit';
	}

	my $server = new JALH::Server(  Port => 6666,
					Spawn => \&client,
					);
	$server->start;
	exit;
}
# Client

&test("Creating client");
my $client = new JALH::Client( Port => 6666 );
my $ch = $client->connect;
&failed if !defined $ch;

&test("Saying hi to server");
print $ch $msg;
my $resp = <$ch>;
&failed unless $resp eq $msg;

&test("Killing all clients on the server");
print $ch "killall\n";
&failed unless $client->disconnected;

&test("Reconnecting to the server");
$ch = $client->connect;		# Reconnect
&failed if !defined $ch;

&test("Killing server");
print $ch "killall\n";
&failed unless $client->disconnected;

&test("Attempting to reconnct to server");
$ch = $client->connect;		# Attempt to reconnect
&failed if defined $ch;

exit;

sub failed {
	print "Test $test Failed :/\n";
	print $ch "quit\n";	# Attempt to kill the server
	exit;
}

sub test {
	print "Test $test passed\n";
	$test++;
	print "Test $test: @_\n";
}
